<?php
/* $Id$ */
/*
 *service_arp.php
 * part of pfSense (https://www.pfsense.org)
 * Copyright (c) 2004-2023 Rubicon Communications, LLC (Netgate)
 * Copyright (c) 2014 Warren Baker (warren@pfsense.org)
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
##|+PRIV
##|*IDENT=page-services-ARP绑定
##|*NAME=Services: ARP绑定
##|*DESCR=Allow access to the 'Services: 网卡绑定' page.
##|*MATCH=services_arp.php*
##|-PRIV

$pgtitle = array(gettext("服务"), gettext("ARP绑定"));
require("guiconfig.inc");
global $config;

$arpcfg = &$config['security']['arp'];

$all_ifinfo = get_all_if_status();
$interfaces = $config['interfaces'];
$arptypes = array('normal' => '正常应答', 'staticarp' => '静态应答', '-arp' => '取消应答');
              
$arplist = trim(str_replace(",","\n",trim($arpcfg['list']))); 
$pconfig['enable'] = isset($config['security']['arp']['enable']);


		 exec("/usr/sbin/arp -an",$rawdata);
		 $data = array();
		 
		 foreach ($rawdata as $line) {
			$elements = explode(' ',$line);
	
			if ($elements[3] != "(incomplete)") {
				$arpent = array();
				$arpent['ip'] = trim(str_replace(array('(',')'),'',$elements[1]));
				$arpent['mac'] = trim($elements[3]);
				$arpent['interface'] = trim($elements[5]);
				$data[] = $arpent;
			}
		 }
		 asort($data);
 		 function get_all_if_status() {
	global $config;
	
	$iflist = get_interface_list();
	$if_status = array();
	foreach($config['interfaces'] as $if_name=>$if_info) {
		if(!is_ipaddr($if_info['ipaddr']) ) continue;
		$if_info['mac']     = $iflist[$if_info['if']]['mac'];
		$if_info['status']  = $iflist[$if_info['if']]['up']?'up':'down';
		$if_info['mask']	  = gen_subnet_mask_long( $if_info['subnet'] ) ;
		$if_info['net']		  = $if_info['mask'] & ip2long($if_info['ipaddr']) ;
		$if_status[$if_name]	= $if_info;
	}
	return $if_status;
}
function arp_bind() {
	global $config;
	$interfaces = $config['interfaces'];
	
	if (isset($config['security']['arp']['enable'])) {
		$arplist = str_replace(",","\n",$config['security']['arp']['list']); 
		#$fill = isset($config['security']['arp']['fill']);
		
		if ($arplist !== "") {
		$fd	= fopen('/tmp/arp.txt','w');
		fwrite($fd,$arplist);
		fclose($fd);
		mwexec('/usr/sbin/arp -d -a && /usr/sbin/arp -f /tmp/arp.txt');
		unlink('/tmp/arp.txt');
		}

		foreach($interfaces as $interfacename => $interface) {
			if ($interfacename == "wan" || $interfacename == "lan" || isset($interface['enable'])) {
					mwexec("/sbin/ifconfig {$interface['if']} arp -staticarp");
				if ($interface['arp'] !== "normal")
					mwexec("/sbin/ifconfig {$interface['if']} {$interface['arp']}");
			}
		}
		
	} else {
		foreach($interfaces as $interfacename => $interface) {
					mwexec("/sbin/ifconfig {$interface['if']} arp -staticarp");
		}
		mwexec("/usr/sbin/arp -d -a");
	}
}
		foreach ($data as $entry) {
			$curlist .= $entry['ip'] . " " . $entry['mac'] . "\n";
		}
		$curlist = ipsort(trim($curlist),"\n");
		//lan arp type
		$pconfig['lanarp'] = $config['interfaces']['lan']['arp'];
		//wan arp type
		$pconfig['wanarp'] = $config['interfaces']['lan']['arp'];
		// each interface arp type
		for ($i = 1; isset($config['interfaces']['opt' . $i]); $i++) {
			if (isset($config['interfaces']['opt' . $i]['enable']));
			$pconfig['opt' . $i . 'arp'] == $config['interfaces']['opt' . $i]['arp'];
			}
		
if ($_POST) {
	$pconfig = $_POST;
	foreach($interfaces as $interface) {
		unset($interface['arp']);
	}
	if ($_POST['copy']) 
		$arplist = $curlist;

	if ($_POST['save']) {
		unset($lista,$listb,$listc,$errors);
		$lista = trim(str_replace("\n",",",trim($_POST['arplist'])));
		$listb = explode(",", $lista);
		foreach($listb as $listc) {
			$listd = explode(" ", trim($listc));
				if (!is_ipaddr($listd[0]) && $_POST['arplist'] !== "") {
					$input_errors['0'] = "列表包含错误的IP地址:{$listd[0]}";
					input_error_js($input_errors);
				}
				if (!is_macaddr($listd[1]) && $_POST['arplist'] !== "") {
					$input_errors['0'] = "列表包含错误的MAC地址:{$listd[1]}";
					input_error_js($input_errors);
				}
		}
		if ($_POST['arplist'] == "" && isset($_POST['enable'])) {
			$input_errors['0'] = "绑定列表为空，不能启用IP&MAC绑定";
			$input_errors['1'] = "services_arp.php";
			input_error_js($input_errors);
		}
			
		if (!$input_errors) {
			$arpcfg['enable'] = $pconfig['enable'] ? true : false;
			$arpcfg['list'] = ipsort($lista,",");

			foreach($interfaces as $interfacename => $interface) {
				if ($interfacename == "wan" || $interfacename == "lan" || isset($interface['enable'])) {
					$config['interfaces'][$interfacename]['arp'] = $pconfig[$interfacename . 'arp'];
				}
			}
			write_config("write config.xml");
			if (isset($arpcfg['enable'])) {
				arp_bind();
				$errors['0'] = "MAC信息已保存并绑定。";
				$errors['1'] = "services_arp.php";
				input_error_js($errors);
				exit;
			} else {
				$errors['0'] = "MAC信息已保存，但未启用绑定。";
				$errors['1'] = "services_arp.php";
				input_error_js($errors);
				exit;
			}
		}
	}
}
$if	= _get_if();
if( isset($_GET['bindMac']) ) { bindMac(); exit(1);}
$msg	= false;
$_MOD	= array(
		'Arp' 			=>	array('List','Save','Run','Now','Bat','AllSave'), 
);
$bAry	= array(
		'filter'	=> '规则策略',
		'shaper'	=> '流量整形',
		'arp'		=> 'ARP绑定',
		'staticroutes'	=> '静态路由',
		'captiveportal'	=> '强制门户',
	);
$mod	= $_MOD[$_GET['mod']] ? $_GET['mod'] : 'Arp';
$act	= in_array($_GET['act'], $_MOD[$mod])? $_GET['act'] :'List';
if( $act!=='List' ) eval("{$mod}$act();");


function & _get_if(){
	global $config;
	$_if	= get_interface_list();
	$a = array();
	foreach($config['interfaces'] as $k=>$v) {
		if( $k=='wan' || !is_ipaddr($v['ipaddr']) ) continue;
		$v['mac']     = $_if[$v['if']]['mac'];
		$v['status']  = $_if[$v['if']]['up']?'up':'down';
		$v['mask']	  = gen_subnet_mask_long( $v['subnet'] ) ;
		$v['net']		  = $v['mask'] & ip2long($v['ipaddr']) ;
		$a[$k]	= $v;
	}
	return $a;
}
function ArpBat(){
	global $config, $msg, $if;	
	$s	= "@echo off\r\n@color 0A\r\n@echo 		Firewall client arp bind script\r\n@echo #####################################################\r\narp -d\r\n";
	$if	= is_array( $if[$_GET['if']] ) ? $if[$_GET['if']]  : $if['lan'];
	$s	.= "arp -s {$if[ipaddr]} ". preg_replace("/\:/","-", $if['mac']). "\r\n" ;
	$list	= @explode(',', $config['security']['arp']['list']);
	if(is_array($list)) foreach($list as $l){
		if( preg_match("/^([\d\.]+)\s+([\w\:]+)/", $l, $a)){
			if( ($if['mask'] & ip2long($a[1]) ) === $if['net']){	
				$mac	= preg_replace("/\:/", "-", $a[2]);
				$s	.= "arp -s $a[1] $mac\r\n";
			}
		}
	}
	$s	.= "arp -a\r\n@echo #####################################################\r\npause";
	session_cache_limiter('public');
	header("Content-Type: application/octet-stream");
	header("Content-Length: ".strlen($s) );
	header("Content-Disposition: attachment; filename=\"".htmlentities('arp_'.$if['if'].'.cmd')."\"\n");
	die($s);
}
function ipsort($ip2sort,$char){
	unset($lista,$listb,$listc);
	$lista = explode($char, $ip2sort);
	foreach($lista as $listb) {
		$listc = explode(" ", trim($listb));
		$tolong[]=array("ip" => ip2long(trim($listc[0])),
                  "mac" => trim($listc[1])
    );              
	}
	sort($tolong);
	foreach($tolong as $valn){
		$toip .= long2ip($valn['ip']) . " " . $valn['mac'] . $char;
	}
	if ($toip !== ""){
		$toip = substr($toip,0,-1);
	}
	return $toip;
}
?>
<?php include("head.inc"); ?>
<form action="" class="form-horizontal" method="post">
    <div class="panel panel-default">
        <div class="panel-heading">
            <h2 class="panel-title">接口信息</h2>
        </div>
        <div class="panel-body">
            <table class="table table-striped table-hover table-condensed sortable-theme-bootstrap">
                <thead>
                    <tr>
                        <th>接口</th>
                        <th>网络端口</th>
                        <th>IP地址</th>
                        <th>MAC地址</th>
                        <th>状态</th>
                        <th>ARP应答方式</th>
                        <th>
                            <div align="center">客户端脚本</div>
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <? foreach($all_ifinfo as $name=>$info) {?>
                    <tr>
                        <td>
                            <?=$name?>
                        </td>
                        <td>
                            <?=$info['if']?>
                        </td>
                        <td>
                            <?=$info['ipaddr'].'/'.$info['subnet']?>
                        </td>
                        <td>
                            <?=$info['mac']?>
                        </td>
                        <td>
                            <?=$info['status']?>
                        </td>
                        <td>
                            <select class="form-control" name="<?=$name?>arp">
                                <?php
                    	foreach ($arptypes as $arptype => $arp) {
                    		echo "<option value=\"$arptype\"";
                    		if ($arptype == $config['interfaces'][$name]['arp'])
                    			echo " selected";
                    		echo ">$arp</option>\n";
                    	}
                    ?>
                            </select>
                        </td>
                        <td align="center">
                            <a href="?mod=Arp&act=Bat&if=<?=$name?>" class="fa fa-download"></a>
                        </td>
                    </tr>
                    <?}?>
                </tbody>
            </table>
        </div>
    </div>
    <div class="panel panel-default">
        <div class="panel-heading">
            <h2 class="panel-title">常规选项</h2>
        </div>
        <div class="panel-body">
            <div class="form-group">
                <label class="col-sm-2 control-label">
                    <span>ARP绑定</span>
                </label>
                <div class="checkbox col-sm-5">
                    <label class="chkboxlbl"><input name="enable" type="checkbox" value="enable" <?php if
                            ($pconfig['enable']) echo "checked" ; ?>> 启用ARP绑定</label>
                </div>
            </div>
            <div class="form-group">
                <label class="col-sm-2 control-label">
                    <span>ARP绑定列表</span>
                </label>
                <label for="textarea"></label>
                <div class="col-sm-5">IP&MAC绑定表
                    <textarea rows="10" class="form-control" name="arplist"><?=$arplist?></textarea>
                    <button class="btn btn-success" type="submit" value="复制当前IP&MAC到绑定表" name="copy" id="copy"><i
                            class="fa fa-plus icon-embed-btn"> </i>复制当前IP&MAC到绑定表</button>
                </div>
                <div class="col-sm-5">当前IP&MAC状态表
                    <textarea rows="10" class="form-control" name="curlist"><?=$curlist?></textarea>
                </div>
            </div>
        </div>
    </div>
    <div class="col-sm-10 col-sm-offset-2"><button class="btn btn-primary" type="submit" value="保存" name="save"><i
                class="fa fa-save icon-embed-btn"> </i>保存</button></div>
    <i class="fa fa-info-circle icon-pointer"
        style="color: #337AB7; font-size:20px; margin-left: 10px; margin-bottom: 10px;" id="showinfo0"
        title="More information">
    </i>
    <div class="infoblock0">
        <div class="alert alert-info clearfix" role="alert">
            <div class="pull-left">
                使用说明:<br />
                1.输入格式请参照右侧当前IP&MAC状态表，可以点击"复制当前IP&MAC到绑定表"按钮将当前状态表复制到左侧的绑定列表。<br />
                2.一旦按下保存，IP&MAC绑定将立刻执行。可以通过对比绑定列表和当前状态表来判断设置是否生效。<br />
                3.必须勾选启用绑定方可生效。<br /><br />
                应答模式:<br />
                1.正常应答，响应所有的ARP应答。这是默认设置。<br />
                2.静态应答，只响应已在绑定列表的ARP应答。未绑定的客户端将无法与网关通讯(推荐)。<br />
                3.取消应答，不响应任何ARP应答。不在绑定列表的客户端，或者客户端没有绑定网关将无法通讯(俗称双绑)。<br />
                ARP的绑定仅需在局域网接口上使用。需要注意，在输入所有IP&MAC配对信息后，才能选中启用ARP绑定选项并保存，否则可能导致未绑定的客户端掉线。<br /><br />
                该插件由天神降临在pfSense2.0中首次发布，后续版本由<a href="https://pfschina.org"target="_blank">鐵血男兒</a>完成适配。
        </div>
    </div>
</form>
<?php
include("foot.inc");
?>